#ifndef __BOOST__IO__FORMAT_TRAITS__HPP
#define __BOOST__IO__FORMAT_TRAITS__HPP
   namespace boost { namespace io
   {
      template< typename T >
      class format_traits              {};

      // formatting for characters:

      template<>
      class format_traits< char >
      {
         public:
            static const char          open_default;
            static const char          close_default;
            static const char          separator_default;
         public:
            static inline bool                   isok( char ) throw();
      };

      // formatting for wide characters:

      template<>
      class format_traits< wchar_t >
      {
         public:
            static const wchar_t       open_default;
            static const wchar_t       close_default;
            static const wchar_t       separator_default;
         public:
            static inline bool                   isok( wchar_t ) throw();
      };

      // formatting for strings:

      template<>
      class format_traits< char * >
      {
         public:
            static char *              open_default;
            static char *              close_default;
            static char *              separator_default;
         public:
            static inline bool                   isok( const char * ) throw();
      };

      template<>
      class format_traits< const char * >: public format_traits< char * >
      {
      };

      // formatting for wide strings:

      template<>
      class format_traits< wchar_t * >
      {
         public:
            static wchar_t *           open_default;
            static wchar_t *           close_default;
            static wchar_t *           separator_default;
         public:
            static inline bool                   isok( const wchar_t * ) throw();
      };

      template<>
      class format_traits< const wchar_t * >: public format_traits< wchar_t * >
      {
      };
   }}
   
#  include "format_traits.ipp"
#endif
